Description

The utility ArtServiceHelper (dunetpc/dune/ArtSupport) enable access to art services outside the art framework but users must
explicitly link against the accessed service libraries. We would like to enable the helper to discover the libraries so this explicit link is
not required.

History

#1 - 09/28/2016 07:31 AM - David Adams

| have asked the art developers for advice on using the existing art code to help with this.

#2 - 09/29/2016 09:37 AM - David Adams

| got some help from Marc:

Hi David,

The facilities that art uses are located in the cetlib package. However, please note that these are facilities
that my need to change during the next several months as we work on a significant multithreading upgrade of a
rt. We are not able to promise to retain backwards compatibility of internal framework facilities as we move f
orward.

The facilities that might be of interest are:

1. cet::LibraryManager in cetlib/LibraryManager.h
The LibraryManager deals with loading dynamic libraries and finding symbols in them.

2. cet::BasicPluginFactory in cetlib/BasicPluginFactory.h
This class provides the facility to invent plugin types, and to create plugins of the invented types.

Documentation for each class can be found in the header of the class. The documentation also mentions a few re
lated facilities that provide the macros we use for declaring types to be plugin types.

I hope this is helpful.

best regards,
Marc

and
Hi David,

I think what you're looking for is
cet::LibraryManager: :getSymbolByLibspec(...)

The 'libspec' argument is the name that the user would put into the FHiCL file to name what he wants loaded. T
he LibraryManager handles all the necessary searching. To keep the system simple to use, we rely upon the nami
ng rules we have chosen for the libraries.

I hope this helps!

#3 - 09/29/2016 09:42 AM - David Adams

However, | find that ArtServiceHelper already does "discovery", i.e. it finds and load service libraries at run time even if they are not included in the
library list for a main program that uses ArtServiceHelper and invokes the service through an interface. | assume this is due to recent change in art.

| have modified the build instructions in dunetpc/dune/DataPrep/Service/test to drop explicit references to the service libraries invoked though
interfaces.
#4 - 09/29/2016 10:16 AM - David Adams
| have also updated the build instructions in dunetpc/dune/DetSim/Service/test. The service library was only dropped for one of the three tests

because the other make direct use of the service.

#5 - 09/29/2016 10:45 AM - David Adams
- Status changed from Assigned to Closed

| close this issue. It turns out the requested feature is already present in the current release (v06_07_00) of dunetpc. The package has been update to
take advantage of the feature for many of its test configurations.
